{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 21-10-2002
  Versión actual: 1.0.0
  Fecha versión actual: 21-10-2002
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------

===============================================================================
}

unit TablaTiposCliente;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dxDBGrid, dxDBCtrl, dbgrids;

type
  TdmTablaTiposCliente = class(TDataModule)
  private
    procedure IniciarSQL;
  public
    sqlInsertar : TStrings;
    sqlModificar : TStrings;
    sqlConsultar : TStrings;
    sqlEliminar : TStrings;
    constructor Create (AOwner : TComponent); override;
    destructor Destroy; override;
    procedure InicializarGridTiposCliente(var Grid: TdxDBGrid);
    function darTiposCliente : TStrings;
  end;

var
  dmTablaTiposCliente: TdmTablaTiposCliente;

implementation

{$R *.DFM}

uses IBSQL, BaseDatos, IB, Excepciones;

{ TdmTablaTiposCliente }

constructor TdmTablaTiposCliente.Create(AOwner: TComponent);
begin
  inherited;
  sqlInsertar := TStringList.Create;
  sqlModificar := TStringList.Create;
  sqlConsultar := TStringList.Create;
  sqlEliminar := TStringList.Create;
  IniciarSQL;
end;

function TdmTablaTiposCliente.darTiposCliente: TStrings;
var
  oSQL : TIBSQL;
  Lista : TStringList;
begin
  oSQL := TIBSQL.Create(Self);
  Lista := TStringList.Create;

  with oSQL do
  begin
    Database := dmBaseDatos.BD;
    Transaction := dmBaseDatos.Transaccion;
    SQL.Add('select DESCRIPCION from TIPOSCLIENTE order by DESCRIPCION');

  try
    Prepare;
    ExecQuery;
    Lista.Append('');
    while not EOF do begin
      Lista.Append(Fields[0].AsString);
      Next;
    end;
    result := Lista;
  finally
    Close;
    Transaction := NIL;
    Free;
  end;
  end;
end;

destructor TdmTablaTiposCliente.Destroy;
begin
  sqlInsertar.Free;
  sqlModificar.Free;
  sqlConsultar.Free;
  sqlEliminar.Free;
  inherited;
end;

procedure TdmTablaTiposCliente.InicializarGridTiposCliente(var Grid: TdxDBGrid);
var
  Columna : TdxDBTreeListColumn;

begin
  with Grid do begin
    DestroyColumns;
    {Columna DESCRIPCION}
    Columna := CreateColumn(TdxDBTreeListColumn);
    Columna.FieldName := 'DESCRIPCION';
    Columna.Caption := 'Tipo de cliente';
  end;
end;

procedure TdmTablaTiposCliente.IniciarSQL;
begin
  with sqlInsertar do
  begin
    Add('insert into TIPOSCLIENTE (DESCRIPCION) ');
    Add('values (UPPER(:DESCRIPCION))');
  end;

  with sqlModificar do
  begin
    Add('update TIPOSCLIENTE set ');
    Add('DESCRIPCION = UPPER(:DESCRIPCION) ');
    Add('where RDB$DB_KEY = :DB_KEY');
  end;

  with sqlEliminar do
  begin
    Add('delete from TIPOSCLIENTE ');
    Add('where DESCRIPCION = :DESCRIPCION');
  end;

  with sqlConsultar do
  begin
    Add('select RDB$DB_KEY, DESCRIPCION ');
    Add('from TIPOSCLIENTE ');
    Add('order by DESCRIPCION');
  end;
end;

end.
